// Generated by CoffeeScript 1.9.2
var Comments, Datarank, Datasources, Fizzle, Live, Locations, Reach, Retailers, Search, Sentiment, Themes, Topics, Volume, Wordcloud;

Topics = require('./datarank/topics');

Comments = require('./datarank/comments');

Datasources = require('./datarank/datasources');

Fizzle = require('./datarank/fizzle');

Live = require('./datarank/live');

Locations = require('./datarank/locations');

Reach = require('./datarank/reach');

Retailers = require('./datarank/retailers');

Search = require('./datarank/search');

Sentiment = require('./datarank/sentiment');

Themes = require('./datarank/themes');

Volume = require('./datarank/volume');

Wordcloud = require('./datarank/wordcloud');

Datarank = (function() {
  Datarank.prototype.client = [];

  function Datarank(apiKey, host, version) {
    this.config = {
      host: host || 'https://api.datarank.com',
      apiKey: apiKey,
      version: version || 'v1'
    };
    this.addResources({
      'topics': Topics,
      'comments': Comments,
      'datasources': Datasources,
      'fizzle': Fizzle,
      'live': Live,
      'locations': Locations,
      'reach': Reach,
      'retailers': Retailers,
      'search': Search,
      'sentiment': Sentiment,
      'themes': Themes,
      'volume': Volume,
      'wordcloud': Wordcloud
    });
  }

  Datarank.prototype.addResources = function(resources) {
    var module, name, results;
    results = [];
    for (name in resources) {
      module = resources[name];
      results.push(this.client[name] = new module(this.config));
    }
    return results;
  };

  return Datarank;

})();

module.exports = Datarank;
