// Generated by CoffeeScript 1.9.2
var BaseClass, request,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

request = require('superagent');

BaseClass = (function() {
  function BaseClass(config) {
    this.config = config;
  }

  BaseClass.prototype.throwError = function(error) {
    error = error.error;
    error.code || (error.code = '');
    error.type || (error.type = 'Error');
    error.message || (error.message = 'Server error');
    return new Error(error.code + " (" + error.type + ") - " + error.message);
  };

  BaseClass.prototype.request = function(method, url, params, callback) {
    var xhr;
    if (method == null) {
      method = 'GET';
    }
    if (url == null) {
      url = '';
    }
    if (params == null) {
      params = {};
    }
    xhr = request[method.toLowerCase()]("" + this.config.host + url);
    xhr.set('Authorization', this.config.apiKey);
    xhr.set('Content-Type', 'application/json');
    xhr.set('Accept', "application/vnd.datarank." + this.config.version + "+json");
    if (method === 'POST') {
      xhr.type('form');
      xhr.send(params);
    } else {
      xhr.query(params);
    }
    return xhr.end((function(_this) {
      return function(err, res) {
        if (err) {
          throw err;
        }
        if (res.ok) {
          return callback(null, res.body);
        } else {
          return callback(_this.throwError(res.body));
        }
      };
    })(this));
  };

  BaseClass.prototype.replaceUrlParams = function(opts, endpoint) {
    var key, value;
    for (key in opts) {
      value = opts[key];
      endpoint = endpoint.replace(":" + key, value);
    }
    return endpoint;
  };

  BaseClass.prototype.validate = {
    obj: function(options, validation) {
      if (options == null) {
        options = {};
      }
      if (validation == null) {
        validation = [];
      }
      validation.forEach(function(value) {
        if (!options[value]) {
          throw new Error("Missing " + value + " parameter.");
        }
      });
      return true;
    },
    str: function(param) {
      if (param == null) {
        param = '';
      }
      if (!param) {
        throw new Error("Missing parameter.");
      }
      return true;
    },
    inclusion: function(param, possibilities) {
      if (param == null) {
        param = '';
      }
      if (indexOf.call(possibilities, param) < 0) {
        throw new Error(param + " isn't a possibility (" + possibilities + ")");
      }
      return true;
    }
  };

  BaseClass.prototype.select = function(collection, param, type) {
    var item, property, selected;
    if (collection == null) {
      collection = [];
    }
    if (param == null) {
      param = {};
    }
    if (type == null) {
      type = 'one';
    }
    this.validate.str(type, ['one', 'all']);
    property = Object.keys(param)[0];
    selected = (function() {
      var i, len, results;
      results = [];
      for (i = 0, len = collection.length; i < len; i++) {
        item = collection[i];
        if (item[property] === param[property]) {
          results.push(item);
        }
      }
      return results;
    })();
    if (selected.length) {
      if (type === 'one') {
        return selected[0];
      }
      if (type === 'all') {
        return selected;
      }
    } else {
      return {};
    }
  };

  return BaseClass;

})();

module.exports = BaseClass;
