BaseClass = require './common/base_class'

class Comments extends BaseClass

  endpoints:
    search: '/topics/:slug/comments'
    row_lookup: '/hbase/row/:row_id'
    top: '/topics/:slug/comments/top'

  # Query interface for comments correlated to a topic
  #
  # * @param slug [String] A topic's unique identifier slug
  # * @option options [1..1000] :limit The number of items to return.
  # * @option options - all query options available in API docs
  search: (slug, opts = {}, callback) ->
    @request 'GET', @replaceUrlParams({'slug': slug}, @endpoints.search), opts, callback

  row_lookup: (row_id, callback, opts = {}) ->
    @request 'GET', @replaceUrlParams({'row_id': row_id}, @endpoints.row_lookup), opts, callback

  top: (slug, opts = {}, callback) ->
    @request 'GET', @replaceUrlParams({'slug': slug}, @endpoints.top), opts, callback

module.exports = Comments
