BaseClass = require './common/base_class'

class Themes extends BaseClass

  endpoints:
    list: '/topics/:slug/themes'
    theme_trend: '/topics/:slug/themes/trend/:theme_id'
    correlations: '/topics/:slug/themes/correlation'

  list: (slug, opts = {}, callback) ->
    @request 'GET', @replaceUrlParams({'slug': slug}, @endpoints.list), opts, callback

  theme_trend: (slug, theme_id, opts = {}, callback) ->
    @request 'GET', @replaceUrlParams({'slug': slug, 'theme_id': theme_id}, @endpoints.theme_trend), opts, callback

  correlations: (slug, theme_id, opts = {}, callback) ->
    @request 'GET', @replaceUrlParams({'slug': slug, 'theme_id': theme_id}, @endpoints.correlations), opts, callback

module.exports = Themes
